package org.directwebremoting.jsp;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;
import org.directwebremoting.Container;
import org.directwebremoting.ScriptBuffer;
import org.directwebremoting.ServerContextFactory;
import org.directwebremoting.WebContextFactory.WebContextBuilder;
import org.directwebremoting.extend.ConverterManager;
import org.directwebremoting.extend.ScriptBufferUtil;

public class ConvertTag extends TagSupport {

   private Object value;
   private boolean json;


   public int doEndTag() throws JspException {
      try {
         Container ex = ServerContextFactory.get().getContainer();
         ConverterManager converterManager = (ConverterManager)ex.getBean(ConverterManager.class);
         HttpServletRequest request = (HttpServletRequest)this.pageContext.getRequest();
         HttpServletResponse response = (HttpServletResponse)this.pageContext.getResponse();
         WebContextBuilder contextBuilder = (WebContextBuilder)ex.getBean(WebContextBuilder.class);
         contextBuilder.engageThread(ex, request, response);

         try {
            ScriptBuffer buffy;
            if(this.json) {
               buffy = new ScriptBuffer();
               buffy.appendData(this.value);
               this.pageContext.getOut().write(ScriptBufferUtil.createOutput(buffy, converterManager, true));
            } else {
               buffy = new ScriptBuffer();
               buffy.appendScript("return ").appendData(this.value).appendScript(";");
               this.pageContext.getOut().write("(function() { " + ScriptBufferUtil.createOutput(buffy, converterManager, false) + " })();");
            }
         } finally {
            contextBuilder.disengageThread();
         }

         return super.doEndTag();
      } catch (Exception var11) {
         throw new JspException(var11);
      }
   }

   public void setValue(Object value) {
      this.value = value;
   }

   public void setJson(boolean json) {
      this.json = json;
   }
}
